var formPortal={};

formPortal.setDebug=
function(debug=null){
   if (debug){
      this.print=function(msg){debug.print(msg);};
      this.clear=function(){debug.clear();}
      return;
   }
   //provide default functions if not debug object is available
   this.print=function(msg){console.log(msg);}
   this.clear=function(){;}
}


formPortal.setDebug();

formPortal.doNothing=
function(){
	this.print('doNothing called');
}

//load runQuery.js

formPortal.printMessage=
function(msg){
	crfHTML.createParagraph(msg,'formDiv')
}


formPortal.init=
function(cb=null){
   let that=this;
   let action=function(){that.scriptsLoaded(cb);};
   LABKEY.Utils.requiresScript(["crf/runQuery.js","crf/formGenerator.js","crf/crfRoleSelector.js","crf/crfSetup.js","crf/crfData.js","crf/crfHTML.js"],action);
}

formPortal.scriptsLoaded=
function(cb=null){
  crfHTML.init();
  crfRoleSelector.set(crfSetup);
  crfData.setSetup(crfSetup);
  let initGenerator=function(){formGenerator.init(cb);};
  let initData=function(){crfData.init(initGenerator);};
  crfSetup.init(initData);
}

formPortal.generateFormArray=
function(){
   let fName='[generateFormArray]';
   this.print(fName);
	this.print(fName);
   let that=this;
   let action=function(){that.afterSetup();};
   let parseSetup=function(){crfSetup.parseSetup(action);};
   crfSetup.setContainers(parseSetup);
	
}

formPortal.filterEntry=
function(entry,filter){
   let fName="[filterEntry]";

   //this.print(fName+' candidate '+entry.entryId);

   if (entry.Form!=filter.form)
      return false;

   //only select forms where status matches the target status
   if (entry.FormStatus!=filter.formStatus){
      return false;
   }

   
   if (crfSetup.getSettings("filterUser") && filter.role=='crfEditor' && entry.UserId!=filter.userId){
      //this.print(fName+' skipping identity mismatch: '+entry.UserId+'/'+filter.userId);  
      return false;
   }

   if (crfSetup.getSettings("filterSite") && entry.Site!=filter.siteNumber){
      //this.print(fName+' skipping site mismatch: '+entry.Site+'/'+filter.siteNumber);  
      return false;

   }
   return true;
}

formPortal.afterSetup=
function(){
   let fName='[afterSetup]';
   this.print(fName);
   let that=this;
   let cb=function(){that.updateForms();};
   crfRoleSelector.makePortal(cb);
	this.table=crfHTML.createTable('formDiv');
}

formPortal.updateForms=
function(){
//this is normallz callback on role selector
   roleAndSite=crfRoleSelector.getRoleAndSite();
   this.drawForms(roleAndSite);
}

formPortal.drawForms=
function(roleAndSite=null){
   let fName="[drawForms]"; 

   if (!roleAndSite){
      alert("Please set role and site");
      return false;
   }

   //set filter
   let ar=roleAndSite.split(":");
   let role=ar[0];
   let filter=new Object();

   filter.role=role;
   filter.siteNumber=ar[1];
   filter.userId=LABKEY.Security.currentUser.id;

   let accessModeColumn=filter.role+'Status';

   
   let formRows=crfSetup.getRows('dataForms');
   //browse through forms
   let fEntries=crfSetup.getRows('crfEntries');

   this.print(fName+' all entries '+fEntries.length);
	for (let i=0;i<formRows.length;i++){

      //dataForms is Forms
		let formEntry=formRows[i];
		let formId=formEntry['Key'];
      
      //set the status for form		
      filter.formStatus=formEntry[accessModeColumn];
      this.print(fName+' target formStatus ['+formEntry['formName']+'] '+filter.formStatus);

		//add row for each form
		let row=this.table.rows[i];
      if (!row) row=this.table.insertRow(i);

      let labelCell=row.cells[0];
      let formName=formEntry['formName'];
      if (!labelCell){
         labelCell=row.insertCell();
         labelCell.innerText=formName;
         crfHTML.addStyle(labelCell,'medium');
         crfHTML.addStyle(labelCell,'center');

         //crfHTML.createParagraph(formName,null,labelCell);
      }
      let cell=row.cells[1];
      if (!cell) {
         cell=row.insertCell();
         crfHTML.addStyle(cell,'stretch');
      }
      crfHTML.clear(cell);

      //update the filter with form idr
      filter.form=formId;
 
      let forms=new Array();

		for (let j=0;j<fEntries.length;j++){
         let entry=fEntries[j];
			if (this.filterEntry(entry,filter))
            forms.push(entry);
		}
      this.displayForms(cell,forms,roleAndSite,formId);
		this.print(fName+' finished checking existing forms');

		//only those that are allowed to create forms
		//print('Status: '+qForm[creatorModeColumn]);
		
	}		  
   if (filter.role=='crfManager')
      //need formGenerator.js
      formGenerator.showFormGenerator(this);
   else
      formGenerator.hideFormGenerator();

}

formPortal.displayForms=
function(el,formList,roleAndSite,formId=null,idLabel=null){
   let fName='[displayForms]';
   //formList is a list of crfEntry entries
   
   let table=crfHTML.createTable(null,el);
   let row=table.insertRow();
   let n=formList.length;
   let that=this;

   for (let i=0;i<n;i++){
      let entry=formList[i];
      let cell=row.insertCell(i);
      crfHTML.addStyle(cell,'stretch');

      let fbox=crfHTML.createBox(null,cell);
      //colormap of formStatus to colors
      let stat=entry['FormStatus'];

      let style=crfSetup.getEntryMap('formStatus')[stat]['color'];
      if (!style) style='gold';
      crfHTML.addStyle(fbox,style);
      this.print(fName+' setting style ['+i+'] '+style);

      let user=crfSetup.getMap('users')[entry['UserId']];
      let idLabel=crfSetup.getParticipantLabel(entry);
      let formStatus=crfSetup.getMap('formStatus')[stat];
      let text=[entry['entryId'],user,idLabel,formStatus];
      fbox.onclick=function(){that.openForm(entry,roleAndSite);};

      for (let j=0;j<text.length;j++){
         crfHTML.createParagraph(text[j],null,fbox);
      }
   }
   if (!formId) return table;
   let formEntry=crfSetup.getEntryMap('dataForms')[formId];
   this.print(fName+' unique '+formEntry['unique']);

   if (n>0 && formEntry['unique']=='TRUE') return table;

   //add empty forms for absent records and non-unique records

   //should not be allowed to create new forms
   let regFormId=crfSetup.getSettings('registrationFormId');
   if (regFormId==formId) return table;
   let cell=row.insertCell(n);
   crfHTML.addStyle(cell,'stretch');
   let fbox=crfHTML.createBox(null,cell);
   crfHTML.addStyle(fbox,'empty');
   fbox.onclick=function(){that.createForm(formId,roleAndSite,idLabel);};
   return table;
   
}

formPortal.openForm=
function(crfEntry,roleAndSite){
   let fName="[openForm]";
	let crfRef=crfEntry.entryId;
	
	this.print(fName+" clicked for "+crfRef);
   let ar=roleAndSite.split(':');
   let role=ar[0];
   let siteNumber=ar[1];


	//select between review and view
	//let formUrl=formEntry["formUrl"];
	//if ("reviewMode" in config) formUrl=formEntry["reviewFormUrl"];
	//print("Setting url "+formUrl);

	//direct all to the same html
	let formUrl="visitNew";

	reviewMode="EDIT";
	let params = {
		"name": formUrl, 
		// The destination wiki page. The name of this parameter is not arbitrary.
		"entryId": crfRef,
		"role" : role
	};

	//"formSetupQuery":formEntry["setupQuery"],
	let containerPath= LABKEY.ActionURL.getContainer();
   // This changes the page after building the URL. 
	//Note that the wiki page destination name is set in params.
   var wikiURL = LABKEY.ActionURL.buildURL("crf", formUrl , containerPath, params);
   this.print(fName+" redirecting to "+wikiURL);

		 
	window.location = wikiURL;
}

formPortal.createForm=
function(formId,roleAndSite,idLabel=null){
   let fName="[createForm]";
   
   let formRow=crfSetup.getEntryMap('dataForms')[formId];
   let creator=formRow['creator'];
   if (!creator) {
      alert("Creator for form "+formRow['formName']+' not set');
      return;
   }
   let ar=roleAndSite.split(':');
   let role=ar[0];
   let siteNumber=ar[1];

   if (creator!=role){
      alert("Can't create form as "+role+' only allowed for '+creator);
      return;
   }

	this.print(fName+" create form w/id "+formId);
	
	let crfEntry=new Object();
	crfEntry.entryId=Date.now();
	crfEntry["Date"]=new Date();
	crfEntry["View"]="[VIEW]";
	crfEntry.formStatus=1;//In progress
	//set other variables
	//requires studyData as part of formConfig
	let studyData=crfSetup.getRows('studyData')[0];
   let varRows=crfSetup.getRows('crfStaticVariables');
   for (let i=0;i<varRows.length;i++){
      let varName=varRows[i].staticVariable;
	   crfEntry[varName]=studyData[varName];
   }
	crfEntry.UserId=LABKEY.Security.currentUser.id;
	crfEntry.Site=siteNumber;
	this.print(fName+" setting site to id="+crfEntry.Site);
	//from argument list
	crfEntry.Form=formId;
   if (idLabel){
      crfEntry[crfSetup.getLocalIdLabel()]=crfSetup.getLocalId(idLabel);
      crfEntry[crfSetup.getStudyIdLabel()]=crfSetup.getStudyId(idLabel);
   }



   let crfStatus=crfData.createCrfStatus(crfEntry);
   crfStatus.operator=role;
   crfStatus.action='createForm';
   let that=this;
   let cb=function(data){that.openForm(crfEntry,roleAndSite);};
   let containerPath=crfSetup.getContainer('data');
   let pass=function(data){runQuery.insertRows('lists','crfStatus',[crfStatus],cb,containerPath);};
   runQuery.insertRows('lists','crfEntry',[crfEntry],pass,containerPath);
}

